﻿using System.Threading.Tasks;
using Azure.Messaging.ServiceBus;
using Microsoft.Azure.WebJobs;
using Microsoft.Azure.WebJobs.ServiceBus;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.Logging;
using NServiceBus;

// ReSharper disable once UnusedMember.Global - triggered by function pipeline
namespace zpadaptbox;

internal class NServiceBusTrigger
{
    #region fields

    private readonly IConfiguration _configuration;

    private readonly IFunctionEndpoint _functionEndpoint;

    #endregion

    #region constructors

    public NServiceBusTrigger(IFunctionEndpoint functionEndpoint, IConfiguration configuration)
    {
        _functionEndpoint = functionEndpoint;
        _configuration = configuration;
    }

    #endregion

    #region methods

    [FunctionName(ApplicationConstants.FunctionName)]
    // ReSharper disable once UnusedMember.Global - executed by Azure Functions Runtime
    public async Task Run(
        [ServiceBusTrigger(ApplicationConstants.QueueName, AutoCompleteMessages = false)]
        ServiceBusReceivedMessage message,
        ServiceBusClient client,
        ServiceBusMessageActions messageActions,
        ILogger logger,
        ExecutionContext executionContext)
    {
        await _functionEndpoint.ProcessAtomic(message, executionContext, client, messageActions, logger);
    }

    #endregion
}